diff --git a/salt/modules/virt.py b/salt/modules/virt.py
index c8e046a47a..a78c21e323 100644
--- a/salt/modules/virt.py
+++ b/salt/modules/virt.py
@@ -1462,162 +1838,142 @@ def init(name,
 
     .. _disk element: https://libvirt.org/formatdomain.html#elementsDisks
     .. _graphics element: https://libvirt.org/formatdomain.html#elementsGraphics
-    '''
-    caps = capabilities(**kwargs)
-    os_types = sorted({guest['os_type'] for guest in caps['guests']})
-    arches = sorted({guest['arch']['name'] for guest in caps['guests']})
-    if not hypervisor:
-        hypervisor = __salt__['config.get']('libvirt:hypervisor', hypervisor)
-        if hypervisor is not None:
-            salt.utils.versions.warn_until(
-                'Sodium',
-                '\'libvirt:hypervisor\' configuration property has been deprecated. '
-                'Rather use the \'virt:connection:uri\' to properly define the libvirt '
-                'URI or alias of the host to connect to. \'libvirt:hypervisor\' will '
-                'stop being used in {version}.'
-            )
-        else:
+    """
+    try:
+        conn = __get_conn(**kwargs)
+        caps = _capabilities(conn)
+        os_types = sorted({guest["os_type"] for guest in caps["guests"]})
+        arches = sorted({guest["arch"]["name"] for guest in caps["guests"]})
+
+        virt_hypervisor = hypervisor
+        if not virt_hypervisor:
             # Use the machine types as possible values
             # Prefer 'kvm' over the others if available
-            hypervisors = sorted({x for y in [guest['arch']['domains'].keys() for guest in caps['guests']] for x in y})
-            hypervisor = 'kvm' if 'kvm' in hypervisors else hypervisors[0]
-
-    # esxi used to be a possible value for the hypervisor: map it to vmware since it's the same
-    hypervisor = 'vmware' if hypervisor == 'esxi' else hypervisor
-
-    log.debug('Using hypervisor %s', hypervisor)
-
-    # the NICs are computed as follows:
-    # 1 - get the default NICs from the profile
-    # 2 - Complete the users NICS
-    # 3 - Update the default NICS list to the users one, matching key is the name
-    dmac = kwargs.get('dmac', None)
-    if dmac:
-        salt.utils.versions.warn_until(
-            'Sodium',
-            '\'dmac\' parameter has been deprecated. Rather use the \'interfaces\' parameter '
-            'to properly define the desired MAC address. \'dmac\' will be removed in {version}.'
-        )
-    nicp = _get_merged_nics(hypervisor, nic, interfaces, dmac=dmac)
-
-    # the disks are computed as follows:
-    # 1 - get the disks defined in the profile
-    # 2 - set the image on the first disk (will be removed later)
-    # 3 - update the disks from the profile with the ones from the user. The matching key is the name.
-    pool = kwargs.get('pool', None)
-    if pool:
-        salt.utils.versions.warn_until(
-            'Sodium',
-            '\'pool\' parameter has been deprecated. Rather use the \'disks\' parameter '
-            'to properly define the vmware datastore of disks. \'pool\' will be removed in {version}.'
-        )
+            hypervisors = sorted(
+                {
+                    x
+                    for y in [
+                        guest["arch"]["domains"].keys() for guest in caps["guests"]
+                    ]
+                    for x in y
+                }
+            )
+            virt_hypervisor = "kvm" if "kvm" in hypervisors else hypervisors[0]
 
-    if image:
-        salt.utils.versions.warn_until(
-            'Sodium',
-            '\'image\' parameter has been deprecated. Rather use the \'disks\' parameter '
-            'to override or define the image. \'image\' will be removed in {version}.'
-        )
+        # esxi used to be a possible value for the hypervisor: map it to vmware since it's the same
+        virt_hypervisor = "vmware" if virt_hypervisor == "esxi" else virt_hypervisor
 
-    diskp = _disk_profile(disk, hypervisor, disks, name, image=image, pool=pool, **kwargs)
+        log.debug("Using hypervisor %s", virt_hypervisor)
 
-    # Create multiple disks, empty or from specified images.
-    for _disk in diskp:
-        log.debug("Creating disk for VM [ %s ]: %s", name, _disk)
+        nicp = _get_merged_nics(virt_hypervisor, nic, interfaces)
 
-        if hypervisor == 'vmware':
-            if 'image' in _disk:
-                # TODO: we should be copying the image file onto the ESX host
-                raise SaltInvocationError(
-                    'virt.init does not support image '
-                    'template in conjunction with esxi hypervisor'
-                )
-            else:
-                # assume libvirt manages disks for us
-                log.debug('Generating libvirt XML for %s', _disk)
-                vol_xml = _gen_vol_xml(
-                    name,
-                    _disk['name'],
-                    _disk['format'],
-                    _disk['size'],
-                    _disk['pool']
-                )
-                define_vol_xml_str(vol_xml)
+        # the disks are computed as follows:
+        # 1 - get the disks defined in the profile
+        # 3 - update the disks from the profile with the ones from the user. The matching key is the name.
+        diskp = _disk_profile(conn, disk, virt_hypervisor, disks, name)
 
-        elif hypervisor in ['qemu', 'kvm', 'xen']:
+        # Create multiple disks, empty or from specified images.
+        for _disk in diskp:
+            # No need to create an image for cdrom devices
+            if _disk.get("device", "disk") == "cdrom":
+                continue
 
-            create_overlay = enable_qcow
-            if create_overlay:
-                salt.utils.versions.warn_until(
-                    'Sodium',
-                    '\'enable_qcow\' parameter has been deprecated. Rather use the \'disks\' '
-                    'parameter to override or define the image. \'enable_qcow\' will be removed '
-                    'in {version}.'
-                )
-            else:
-                create_overlay = _disk.get('overlay_image', False)
+            log.debug("Creating disk for VM [ %s ]: %s", name, _disk)
 
-            if _disk['source_file']:
-                if os.path.exists(_disk['source_file']):
-                    img_dest = _disk['source_file']
+            if virt_hypervisor == "vmware":
+                if "image" in _disk:
+                    # TODO: we should be copying the image file onto the ESX host
+                    raise SaltInvocationError(
+                        "virt.init does not support image "
+                        "template in conjunction with esxi hypervisor"
+                    )
                 else:
-                    img_dest = _qemu_image_create(_disk, create_overlay, saltenv)
-            else:
-                img_dest = None
-
-            # Seed only if there is an image specified
-            if seed and img_dest and _disk.get('image', None):
-                log.debug('Seed command is %s', seed_cmd)
-                __salt__[seed_cmd](
-                    img_dest,
-                    id_=name,
-                    config=kwargs.get('config'),
-                    install=install,
-                    pub_key=pub_key,
-                    priv_key=priv_key,
+                    # assume libvirt manages disks for us
+                    log.debug("Generating libvirt XML for %s", _disk)
+                    volume_name = "{0}/{1}".format(name, _disk["name"])
+                    filename = "{0}.{1}".format(volume_name, _disk["format"])
+                    vol_xml = _gen_vol_xml(
+                        filename, _disk["size"], format=_disk["format"]
+                    )
+                    _define_vol_xml_str(conn, vol_xml, pool=_disk.get("pool"))
+
+            elif virt_hypervisor in ["qemu", "kvm", "xen"]:
+
+                def seeder(path):
+                    _seed_image(
+                        seed_cmd,
+                        path,
+                        name,
+                        kwargs.get("config"),
+                        install,
+                        pub_key,
+                        priv_key,
+                    )
+
+                create_overlay = _disk.get("overlay_image", False)
+                format = _disk.get("format")
+                if _disk.get("source_file"):
+                    if os.path.exists(_disk["source_file"]):
+                        img_dest = _disk["source_file"]
+                    else:
+                        img_dest = _qemu_image_create(_disk, create_overlay, saltenv)
+                else:
+                    _disk_volume_create(conn, _disk, seeder if seed else None, saltenv)
+                    img_dest = None
+
+                # Seed only if there is an image specified
+                if seed and img_dest and _disk.get("image", None):
+                    seeder(img_dest)
+
+            elif hypervisor in ["bhyve"]:
+                img_dest = _zfs_image_create(
+                    vm_name=name,
+                    pool=_disk.get("pool"),
+                    disk_name=_disk.get("name"),
+                    disk_size=_disk.get("size"),
+                    disk_image_name=_disk.get("image"),
+                    hostname_property_name=_disk.get("hostname_property"),
+                    sparse_volume=_disk.get("sparse_volume"),
                 )
 
-        else:
-            # Unknown hypervisor
-            raise SaltInvocationError(
-                'Unsupported hypervisor when handling disk image: {0}'
-                .format(hypervisor)
-            )
-
-    log.debug('Generating VM XML')
+            else:
+                # Unknown hypervisor
+                raise SaltInvocationError(
+                    "Unsupported hypervisor when handling disk image: {0}".format(
+                        virt_hypervisor
+                    )
+                )
 
-    if enable_vnc:
-        salt.utils.versions.warn_until(
-            'Sodium',
-            '\'enable_vnc\' parameter has been deprecated in favor of '
-            '\'graphics\'. Use graphics={\'type\': \'vnc\'} for the same behavior. '
-            '\'enable_vnc\' will be removed in {version}. ')
-        graphics = {'type': 'vnc'}
+        log.debug("Generating VM XML")
+        if os_type is None:
+            os_type = "hvm" if "hvm" in os_types else os_types[0]
+        if arch is None:
+            arch = "x86_64" if "x86_64" in arches else arches[0]
 
-    if os_type is None:
-        os_type = 'hvm' if 'hvm' in os_types else os_types[0]
-    if arch is None:
-        arch = 'x86_64' if 'x86_64' in arches else arches[0]
+        if boot is not None:
+            boot = _handle_remote_boot_params(boot)
 
-    if boot is not None:
-        boot = _handle_remote_boot_params(boot)
-
-    vm_xml = _gen_xml(name, cpu, mem, diskp, nicp, hypervisor, os_type, arch,
-                      graphics, boot, **kwargs)
-    conn = __get_conn(**kwargs)
-    try:
+        vm_xml = _gen_xml(
+            conn,
+            name,
+            cpu,
+            mem,
+            diskp,
+            nicp,
+            virt_hypervisor,
+            os_type,
+            arch,
+            graphics,
+            boot,
+            **kwargs
+        )
         conn.defineXML(vm_xml)
-    except libvirtError as err:
-        # check if failure is due to this domain already existing
-        if "domain '{}' already exists".format(name) in six.text_type(err):
-            # continue on to seeding
-            log.warning(err)
-        else:
-            conn.close()
-            raise err  # a real error we should report upwards
+    except libvirt.libvirtError as err:
+        conn.close()
+        raise CommandExecutionError(err.get_error_message())
 
     if start:
-        log.debug('Starting VM %s', name)
+        log.debug("Starting VM %s", name)
         _get_domain(conn, name).create()
     conn.close()
 
@@ -1625,66 +1981,107 @@ def init(name,
 
 
 def _disks_equal(disk1, disk2):
-    '''
+    """
     Test if two disk elements should be considered like the same device
-    '''
-    target1 = disk1.find('target')
-    target2 = disk2.find('target')
-    source1 = ElementTree.tostring(disk1.find('source')) if disk1.find('source') is not None else None
-    source2 = ElementTree.tostring(disk2.find('source')) if disk2.find('source') is not None else None
+    """
+    target1 = disk1.find("target")
+    target2 = disk2.find("target")
+    source1 = (
+        disk1.find("source")
+        if disk1.find("source") is not None
+        else ElementTree.Element("source")
+    )
+    source2 = (
+        disk2.find("source")
+        if disk2.find("source") is not None
+        else ElementTree.Element("source")
+    )
 
-    return source1 == source2 and \
-        target1 is not None and target2 is not None and \
-        target1.get('bus') == target2.get('bus') and \
-        disk1.get('device', 'disk') == disk2.get('device', 'disk') and \
-        target1.get('dev') == target2.get('dev')
+    source1_dict = xmlutil.to_dict(source1, True)
+    source2_dict = xmlutil.to_dict(source2, True)
+
+    # Remove the index added by libvirt in the source for backing chain
+    if source1_dict:
+        source1_dict.pop("index", None)
+    if source2_dict:
+        source2_dict.pop("index", None)
+
+    return (
+        source1_dict == source2_dict
+        and target1 is not None
+        and target2 is not None
+        and target1.get("bus") == target2.get("bus")
+        and disk1.get("device", "disk") == disk2.get("device", "disk")
+        and target1.get("dev") == target2.get("dev")
+    )
 
 
 def _nics_equal(nic1, nic2):
-    '''
+    """
     Test if two interface elements should be considered like the same device
-    '''
+    """
 
     def _filter_nic(nic):
-        '''
+        """
         Filter out elements to ignore when comparing nics
-        '''
+        """
         return {
-            'type': nic.attrib['type'],
-            'source': nic.find('source').attrib[nic.attrib['type']] if nic.find('source') is not None else None,
-            'mac': nic.find('mac').attrib['address'].lower() if nic.find('mac') is not None else None,
-            'model': nic.find('model').attrib['type'] if nic.find('model') is not None else None,
+            "type": nic.attrib["type"],
+            "source": nic.find("source").attrib[nic.attrib["type"]]
+            if nic.find("source") is not None
+            else None,
+            "model": nic.find("model").attrib["type"]
+            if nic.find("model") is not None
+            else None,
         }
-    return _filter_nic(nic1) == _filter_nic(nic2)
+
+    def _get_mac(nic):
+        return (
+            nic.find("mac").attrib["address"].lower()
+            if nic.find("mac") is not None
+            else None
+        )
+
+    mac1 = _get_mac(nic1)
+    mac2 = _get_mac(nic2)
+    macs_equal = not mac1 or not mac2 or mac1 == mac2
+    return _filter_nic(nic1) == _filter_nic(nic2) and macs_equal
 
 
 def _graphics_equal(gfx1, gfx2):
-    '''
+    """
     Test if two graphics devices should be considered the same device
-    '''
+    """
+
     def _filter_graphics(gfx):
-        '''
+        """
         When the domain is running, the graphics element may contain additional properties
         with the default values. This function will strip down the default values.
-        '''
+        """
         gfx_copy = copy.deepcopy(gfx)
 
-        defaults = [{'node': '.', 'attrib': 'port', 'values': ['5900', '-1']},
-                    {'node': '.', 'attrib': 'address', 'values': ['127.0.0.1']},
-                    {'node': 'listen', 'attrib': 'address', 'values': ['127.0.0.1']}]
+        defaults = [
+            {"node": ".", "attrib": "port", "values": ["5900", "-1"]},
+            {"node": ".", "attrib": "address", "values": ["127.0.0.1"]},
+            {"node": "listen", "attrib": "address", "values": ["127.0.0.1"]},
+        ]
 
         for default in defaults:
-            node = gfx_copy.find(default['node'])
-            attrib = default['attrib']
-            if node is not None and (attrib not in node.attrib or node.attrib[attrib] in default['values']):
-                node.set(attrib, default['values'][0])
+            node = gfx_copy.find(default["node"])
+            attrib = default["attrib"]
+            if node is not None and (
+                attrib in node.attrib and node.attrib[attrib] in default["values"]
+            ):
+                node.attrib.pop(attrib)
         return gfx_copy
 
-    return ElementTree.tostring(_filter_graphics(gfx1)) == ElementTree.tostring(_filter_graphics(gfx2))
+    return xmlutil.to_dict(_filter_graphics(gfx1), True) == xmlutil.to_dict(
+        _filter_graphics(gfx2), True
+    )
 
 
 def _diff_lists(old, new, comparator):
-    '''
+    """
     Compare lists to extract the changes
 
     :param old: old list
@@ -1693,99 +2090,111 @@ def _diff_lists(old, new, comparator):
 
     The sorted list is the union of unchanged and new lists, but keeping the original
     order from the new list.
-    '''
+    """
+
     def _remove_indent(node):
-        '''
+        """
         Remove the XML indentation to compare XML trees more easily
-        '''
+        """
         node_copy = copy.deepcopy(node)
         node_copy.text = None
         for item in node_copy.iter():
             item.tail = None
         return node_copy
 
-    diff = {'unchanged': [], 'new': [], 'deleted': [], 'sorted': []}
+    diff = {"unchanged": [], "new": [], "deleted": [], "sorted": []}
     # We don't want to alter old since it may be used later by caller
     old_devices = copy.deepcopy(old)
     for new_item in new:
-        found = [item for item in old_devices if comparator(_remove_indent(item), _remove_indent(new_item))]
+        found = [
+            item
+            for item in old_devices
+            if comparator(_remove_indent(item), _remove_indent(new_item))
+        ]
         if found:
             old_devices.remove(found[0])
-            diff['unchanged'].append(found[0])
-            diff['sorted'].append(found[0])
+            diff["unchanged"].append(found[0])
+            diff["sorted"].append(found[0])
         else:
-            diff['new'].append(new_item)
-            diff['sorted'].append(new_item)
-    diff['deleted'] = old_devices
+            diff["new"].append(new_item)
+            diff["sorted"].append(new_item)
+    diff["deleted"] = old_devices
     return diff
 
 
+def _get_disk_target(targets, disks_count, prefix):
+    """
+    Compute the disk target name for a given prefix.
+
+    :param targets: the list of already computed targets
+    :param disks: the number of disks
+    :param prefix: the prefix of the target name, i.e. "hd"
+    """
+    return [
+        "{0}{1}".format(prefix, string.ascii_lowercase[i])
+        for i in range(disks_count)
+        if "{0}{1}".format(prefix, string.ascii_lowercase[i]) not in targets
+    ][0]
+
+
 def _diff_disk_lists(old, new):
-    '''
+    """
     Compare disk definitions to extract the changes and fix target devices
 
     :param old: list of ElementTree nodes representing the old disks
     :param new: list of ElementTree nodes representing the new disks
-    '''
+    """
     # Change the target device to avoid duplicates before diffing: this may lead
     # to additional changes. Think of unchanged disk 'hda' and another disk listed
     # before it becoming 'hda' too... the unchanged need to turn into 'hdb'.
     targets = []
-    prefixes = ['fd', 'hd', 'vd', 'sd', 'xvd', 'ubd']
+    prefixes = ["fd", "hd", "vd", "sd", "xvd", "ubd"]
     for disk in new:
-        target_node = disk.find('target')
-        target = target_node.get('dev')
+        target_node = disk.find("target")
+        target = target_node.get("dev")
         prefix = [item for item in prefixes if target.startswith(item)][0]
-        new_target = ['{0}{1}'.format(prefix, string.ascii_lowercase[i]) for i in range(len(new))
-                      if '{0}{1}'.format(prefix, string.ascii_lowercase[i]) not in targets][0]
-        target_node.set('dev', new_target)
+        new_target = _get_disk_target(targets, len(new), prefix)
+        target_node.set("dev", new_target)
         targets.append(new_target)
 
     return _diff_lists(old, new, _disks_equal)
 
 
 def _diff_interface_lists(old, new):
-    '''
+    """
     Compare network interface definitions to extract the changes
 
     :param old: list of ElementTree nodes representing the old interfaces
     :param new: list of ElementTree nodes representing the new interfaces
-    '''
-    diff = _diff_lists(old, new, _nics_equal)
-
-    # Remove duplicated addresses mac addresses and let libvirt generate them for us
-    macs = [nic.find('mac').get('address') for nic in diff['unchanged']]
-    for nic in diff['new']:
-        mac = nic.find('mac')
-        if mac.get('address') in macs:
-            nic.remove(mac)
-
-    return diff
+    """
+    return _diff_lists(old, new, _nics_equal)
 
 
 def _diff_graphics_lists(old, new):
-    '''
+    """
     Compare graphic devices definitions to extract the changes
 
     :param old: list of ElementTree nodes representing the old graphic devices
     :param new: list of ElementTree nodes representing the new graphic devices
-    '''
+    """
     return _diff_lists(old, new, _graphics_equal)
 
 
-def update(name,
-           cpu=0,
-           mem=0,
-           disk_profile=None,
-           disks=None,
-           nic_profile=None,
-           interfaces=None,
-           graphics=None,
-           live=True,
-           boot=None,
-           test=False,
-           **kwargs):
-    '''
+def update(
+    name,
+    cpu=0,
+    mem=0,
+    disk_profile=None,
+    disks=None,
+    nic_profile=None,
+    interfaces=None,
+    graphics=None,
+    live=True,
+    boot=None,
+    test=False,
+    **kwargs
+):
+    """
     Update the definition of an existing domain.
 
     :param name: Name of the domain to update
@@ -1820,19 +2229,13 @@ def update(name,
     :param password: password to connect with, overriding defaults
 
     :param boot:
-        Specifies kernel for the virtual machine, as well as boot parameters
-        for the virtual machine. This is an optionl parameter, and all of the
-        keys are optional within the dictionary. If a remote path is provided
-        to kernel or initrd, salt will handle the downloading of the specified
-        remote fild, and will modify the XML accordingly.
+        Specifies kernel, initial ramdisk and kernel command line parameters for the virtual machine.
+        This is an optional parameter, all of the keys are optional within the dictionary.
 
-        .. code-block:: python
+        Refer to :ref:`init-boot-def` for the complete boot parameter description.
 
-            {
-                'kernel': '/root/f8-i386-vmlinuz',
-                'initrd': '/root/f8-i386-initrd',
-                'cmdline': 'console=ttyS0 ks=http://example.com/f8-i386/os/'
-            }
+        To update any boot parameters, specify the new path for each. To remove any boot parameters,
+        pass a None object, for instance: 'kernel': ``None``.
 
         .. versionadded:: 3000
 
@@ -1866,11 +2269,11 @@ def update(name,
 
         salt '*' virt.update domain cpu=2 mem=1024
 
-    '''
+    """
     status = {
-        'definition': False,
-        'disk': {'attached': [], 'detached': []},
-        'interface': {'attached': [], 'detached': []}
+        "definition": False,
+        "disk": {"attached": [], "detached": [], "updated": []},
+        "interface": {"attached": [], "detached": []},
     }
     conn = __get_conn(**kwargs)
     domain = _get_domain(conn, name)
@@ -1878,56 +2281,68 @@ def update(name,
     need_update = False
 
     # Compute the XML to get the disks, interfaces and graphics
-    hypervisor = desc.get('type')
-    all_disks = _disk_profile(disk_profile, hypervisor, disks, name, **kwargs)
+    hypervisor = desc.get("type")
+    all_disks = _disk_profile(conn, disk_profile, hypervisor, disks, name)
 
     if boot is not None:
         boot = _handle_remote_boot_params(boot)
 
-    new_desc = ElementTree.fromstring(_gen_xml(name,
-                                               cpu or 0,
-                                               mem or 0,
-                                               all_disks,
-                                               _get_merged_nics(hypervisor, nic_profile, interfaces),
-                                               hypervisor,
-                                               domain.OSType(),
-                                               desc.find('.//os/type').get('arch'),
-                                               graphics,
-                                               boot,
-                                               **kwargs))
+    new_desc = ElementTree.fromstring(
+        _gen_xml(
+            conn,
+            name,
+            cpu or 0,
+            mem or 0,
+            all_disks,
+            _get_merged_nics(hypervisor, nic_profile, interfaces),
+            hypervisor,
+            domain.OSType(),
+            desc.find(".//os/type").get("arch"),
+            graphics,
+            boot,
+            **kwargs
+        )
+    )
 
     # Update the cpu
-    cpu_node = desc.find('vcpu')
+    cpu_node = desc.find("vcpu")
     if cpu and int(cpu_node.text) != cpu:
         cpu_node.text = six.text_type(cpu)
-        cpu_node.set('current', six.text_type(cpu))
+        cpu_node.set("current", six.text_type(cpu))
         need_update = True
 
     # Update the kernel boot parameters
-    boot_tags = ['kernel', 'initrd', 'cmdline']
-    parent_tag = desc.find('os')
+    boot_tags = ["kernel", "initrd", "cmdline", "loader", "nvram"]
+    parent_tag = desc.find("os")
 
     # We need to search for each possible subelement, and update it.
     for tag in boot_tags:
         # The Existing Tag...
-        found_tag = desc.find(tag)
+        found_tag = parent_tag.find(tag)
 
         # The new value
         boot_tag_value = boot.get(tag, None) if boot else None
 
         # Existing tag is found and values don't match
-        if found_tag and found_tag.text != boot_tag_value:
+        if found_tag is not None and found_tag.text != boot_tag_value:
 
             # If the existing tag is found, but the new value is None
             # remove it. If the existing tag is found, and the new value
             # doesn't match update it. In either case, mark for update.
-            if boot_tag_value is None \
-               and boot is not None   \
-               and parent_tag is not None:
-                ElementTree.remove(parent_tag, tag)
+            if boot_tag_value is None and boot is not None and parent_tag is not None:
+                parent_tag.remove(found_tag)
             else:
                 found_tag.text = boot_tag_value
 
+            # If the existing tag is loader or nvram, we need to update the corresponding attribute
+            if found_tag.tag == "loader" and boot_tag_value is not None:
+                found_tag.set("readonly", "yes")
+                found_tag.set("type", "pflash")
+
+            if found_tag.tag == "nvram" and boot_tag_value is not None:
+                found_tag.set("template", found_tag.text)
+                found_tag.text = None
+
             need_update = True
 
         # Existing tag is not found, but value is not None
